<template>
  <div class="bt-container">
    <el-row>
      <el-col
        v-for="item in openedClassList"
        :key="item.class_id"
        :span="8"
        style="padding: 5px;"
      >
        <class-intro-card
          :title="item.name"
          :description="item.description"
          :classId="item.class_id"
          :onClick="onClick"
          :label-span="5"
          :teacher-list="[item.master.email_id]"
          :start-date-str="formatDate(item.start_item)"
          :end-date-str="formatDate(item.end_time)"
        />
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import ClassIntroCard from '../partials/ClassIntroCard';
import utils from '../../utils';

export default {
  name: 'ClassIndexCard',
  components: {
    ClassIntroCard,
  },
  mounted() {
    const vm = this;
    vm.getClassLists();
  },
  computed: {
    ...mapState('class', ['openedClassList']),
  },
  methods: {
    ...mapActions('class', [
      'getClassLists',
      'getMyClassLists',
      'postClassUser',
    ]),
    formatDate: utils.formatDate,
    async onClick(type, data) {
      const vm = this;
      switch (type) {
        case 'APPLY': {
          try {
            await vm.postClassUser({
              classId: data,
            });
            vm.$notify({
              title: vm.$t('NOTIFY.CR_SGN_UP_REQ_SC'),
              message: vm.$t('NOTIFY.MESSAGE'),
              type: 'success',
            });
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.CR_SGN_UP_REQ_FL'),
              message: error.toString(),
              type: 'error',
              duration: 0,
            });
          }

          try {
            await vm.getMyClassLists();
            await vm.getClassLists();
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.FAIL_IMP_SUBJ_LIST'),
              message: error.toString(),
              type: 'error',
              duration: 0,
            });
          }
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
};
</script>


<style lang="scss">
.bt-container .el-col-8{
  /* border:1px solid red; */
  width:22%;
  margin-left:15px;
  margin-top:25px;
}


</style>